//
//  SaldoParmViewController.swift
//  WiRIS
//
//  Created by William on 15/01/2017.
//  Copyright © 2017 Parse. All rights reserved.
//

import UIKit

class SaldoParmViewController: UITableViewController, UIPickerViewDataSource, UIPickerViewDelegate {
    
    @IBOutlet var ucetDetail: UILabel!
    @IBOutlet var rokDetail: UILabel!
    @IBOutlet var mesicOdDetail: UILabel!
    @IBOutlet var mesicDoDetail: UILabel!
 
    @IBOutlet var ucetPicker: UIPickerView!
    @IBOutlet var rokPicker: UIPickerView!
    @IBOutlet var mesicOdPicker: UIPickerView!
    @IBOutlet var mesicDoPicker: UIPickerView!
    
    func displayAlert (title: String,message: String) {
        
        if #available(iOS 8.0, *) {
            let alert = UIAlertController(title: title, message: message, preferredStyle: UIAlertControllerStyle.Alert)
            alert.addAction(UIAlertAction(title: "OK", style: .Default, handler: { (action) in
                
                self.dismissViewControllerAnimated(true, completion: nil)
                
            }))
            
            self.presentViewController(alert, animated: true, completion: nil)
            
        } else {
            // Fallback
        }
        
    }
    
    var pickerUcetHidden = true
    var pickerRokHidden = true
    var pickerMesicOdHidden = true
    var pickerMesicDoHidden = true
    
    var pickerUcetData: [String] = [String]()
    var pickerRokData: [String] = [String]()
    var pickerMesicOdData: [String] = [String]()
    var pickerMesicDoData: [String] = [String]()
    
    var ucet = String()
    var rok = String()
    var mesicOd = String()
    var mesicDo = String()

    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.ucetPicker.delegate = self
        self.ucetPicker.dataSource = self
        self.rokPicker.delegate = self
        self.rokPicker.dataSource = self
        self.mesicOdPicker.delegate = self
        self.mesicOdPicker.dataSource = self
        self.mesicDoPicker.delegate = self
        self.mesicDoPicker.dataSource = self
        
        pickerUcetData = ["Odběratelské", "Dodavatelské"]
        pickerRokData = ["2014", "2015", "2016"]
        pickerMesicOdData = ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"]
        pickerMesicDoData = ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"]
        
        ucet = pickerUcetData[0]
        rok = pickerRokData[0]
        mesicOd = pickerMesicOdData[0]
        mesicDo = pickerMesicDoData[0]
        
        self.ucetDetail.text = ucet
        self.rokDetail.text = rok
        self.mesicOdDetail.text = mesicOd
        self.mesicDoDetail.text = mesicDo
        
        tableView.beginUpdates()
        tableView.endUpdates()
        
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func numberOfComponentsInPickerView(pickerView: UIPickerView) -> Int {
        
        switch pickerView.tag {
        case 1:
            return 1
        case 2:
            return 1
        case 3:
            return 1
        case 4:
            return 1
        default:
            return 0
        }
    }
    
    func pickerView(pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        
        switch pickerView.tag {
        case 1:
            return pickerUcetData.count
        case 2:
            return pickerRokData.count
        case 3:
            return pickerMesicOdData.count
        case 4:
            return pickerMesicDoData.count
        default:
            return 0
        }
        
    }
    
    func pickerView(pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        
        switch pickerView.tag {
        case 1:
            return pickerUcetData[row]
        case 2:
            return pickerRokData[row]
        case 3:
            return pickerMesicOdData[row]
        case 4:
            return pickerMesicDoData[row]
        default:
            return nil
        }
        
    }
    
    func pickerView(pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        
        switch pickerView.tag {
        case 1:
            ucet = pickerUcetData[row]
            self.ucetDetail.text = ucet
        case 2:
            rok = pickerRokData[row]
            self.rokDetail.text = rok
        case 3:
            mesicOd = pickerMesicOdData[row]
            self.mesicOdDetail.text = mesicOd
        case 4:
            mesicDo = pickerMesicDoData[row]
            self.mesicDoDetail.text = mesicDo
        default:
            break
        }
        
    }
    
    override func tableView(tableView: UITableView, heightForRowAtIndexPath indexPath: NSIndexPath) -> CGFloat {
        
        if pickerUcetHidden && indexPath.section == 0 && indexPath.row == 1 {
            return 0
        }
        
        else if pickerRokHidden && indexPath.section == 1 && indexPath.row == 1 {
            return 0
        }
        
        else if pickerMesicOdHidden && indexPath.section == 2 && indexPath.row == 1 {
            return 0
        }
        
        else if pickerMesicDoHidden && indexPath.section == 2 && indexPath.row == 3 {
            return 0
        }
        
        else {
            return super.tableView(tableView, heightForRowAtIndexPath: indexPath)
        }
        
    }
    
    override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        
        if indexPath.row == 0 && indexPath.section == 0 {
            
            pickerUcetHidden = !pickerUcetHidden
            
            tableView.beginUpdates()
            tableView.endUpdates()
            
        }
        
        if indexPath.row == 0 && indexPath.section == 1 {
            
            pickerRokHidden = !pickerRokHidden
            
            tableView.beginUpdates()
            tableView.endUpdates()
            
        }
        
        if indexPath.row == 0 && indexPath.section == 2 {
            
            pickerMesicOdHidden = !pickerMesicOdHidden
            
            tableView.beginUpdates()
            tableView.endUpdates()
            
        }
        
        if indexPath.row == 2 && indexPath.section == 2 {
            
            pickerMesicDoHidden = !pickerMesicDoHidden
            
            tableView.beginUpdates()
            tableView.endUpdates()
            
        }
        
        if indexPath.row == 0 && indexPath.section == 3 {
            
            if mesicOd > mesicDo {
                
                self.displayAlert("Chyba", message: "Měsíc od musí být menší než měsíc do!")
                
            } else {
                
                performSegueWithIdentifier("Saldo", sender: self)
                
            }
            
        }
        
    }
    
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        
        let destViewController : SaldoTableViewController = segue.destinationViewController as! SaldoTableViewController
        
        destViewController.ucet = self.ucet
        destViewController.rok = Int(self.rok)!
        destViewController.mesicOd = Int(self.mesicOd)!
        destViewController.mesicDo = Int(self.mesicDo)!
        
    }

}
