//
//  SaldoTableViewController.swift
//  WiRIS
//
//  Created by William on 08/01/2017.
//  Copyright © 2017 Parse. All rights reserved.
//

import UIKit
import Parse

class SaldoTableViewController: UITableViewController {
    
    
    var ucet = String()
    var rok = Int()
    var mesicOd = Int()
    var mesicDo = Int()
    
    var ucetCis = String()
    
    var sumUcet = [String: Int]()
    
    var activityIndicator = UIActivityIndicatorView()

    override func viewDidLoad() {
        super.viewDidLoad()
        
        if ucet == "Odběratelské" {
            
            ucetCis = "31"
            
        } else if ucet == "Dodavatelské" {
            
            ucetCis = "32"
            
        }
        
        
        let query = PFQuery(className: "doklad")
        query.whereKey("rok", equalTo: rok)
        query.whereKey("mesic", lessThanOrEqualTo: mesicDo)
        query.whereKey("mesic", greaterThanOrEqualTo: mesicOd)
        query.whereKey("ucet", hasPrefix: ucetCis)
        query.limit = 100000
        
        query.findObjectsInBackgroundWithBlock({ (objects:[PFObject]?, error:NSError?) in

            var ucetId: String = ""
            
            if error == nil {
                
                for object in objects! as [PFObject] {
                    
                    ucetId = object["ucet"] as! String
                    
                    if self.sumUcet[ucetId] == nil {
                    
                    self.sumUcet[ucetId] = (object["kcm"] as! Int) - (object["kcd"] as! Int)
                        
                    } else {
                        
                        self.sumUcet[ucetId]! = self.sumUcet[ucetId]! + (object["kcm"] as! Int) - (object["kcd"] as! Int)
                        
                    }
                    
                    
                    self.tableView.reloadData()
                    
                }
                
            }
            
        })

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return sumUcet.count
    }

    
    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("cell", forIndexPath: indexPath)
        
        
        
        let key = Array(self.sumUcet.keys)[indexPath.row]
        let value = Array(self.sumUcet.values)[indexPath.row]
        
        cell.textLabel?.text = "Účet " + key + " za dané období: " + String(value) + " Kč"

        return cell
    }
 
}
